gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/AdminBean.java
package net.ihe.gazelle.token.interlay.ihm;

import net.ihe.gazelle.token.application.service.IPreferenceService;
import net.ihe.gazelle.token.application.service.ITokenService;
import net.ihe.gazelle.token.domain.entity.Preference;
import net.ihe.gazelle.token.domain.entity.Token;
import net.ihe.gazelle.token.interlay.annotation.LogAudited;
import net.ihe.gazelle.token.interlay.dao.exception.DaoException;
import net.ihe.gazelle.token.interlay.ihm.model.GetPrincipal;
import net.ihe.gazelle.token.interlay.ihm.util.GrowlBean;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import javax.transaction.Transactional;
import java.io.IOException;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * @author Claude LUSSEAU
 * @company KEREVAL
 * @project gazelle-token
 * @date 08/07/2022
 */
@Named
@LogAudited
public class AdminBean implements Serializable {

    private boolean admin = false;

    private int duration;
    private Preference preference;

    @Inject
    private GrowlBean growlBean;
    @Inject
    private IPreferenceService preferenceService;
    @Inject
    private ITokenService tokenService;
    @Inject
    private GetPrincipal getPrincipal;

    @PostConstruct
    public void init() throws IOException {
        FacesContext context = FacesContext.getCurrentInstance();
        if (getPrincipal.isAdmin()) {
            admin = true;
        } else {
            ExternalContext externalContext = context.getExternalContext();
            externalContext.redirect(externalContext.getRequestContextPath());
            context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "", "Vous n'avez pas les droits necessaires pour accéder à cette partie de l'application"));
        }
    }

    public boolean isExpired(String value) {
        Token token = tokenService.findByValue(value);
        return !token.getExpirationDate().isBefore(LocalDateTime.now());
    }


    @Transactional
    public void setDuration(int value) throws DaoException {
        if (value > 365) {
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "", "La durée de vie des tokens ne peut exéder 365 jours"));
        }
        if (value < 1){
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "", "La durée de vie des tokens ne peut être inférieur à 1 jour"));
        }
        if (value <= 365 && value > 0) {
            this.preferenceService.setDuration(value);
            FacesContext context = FacesContext.getCurrentInstance();
            context.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,"", "La durée de vie des tokens est désormais de " + value + " jours"));
        }
    }

    public int getDuration() {
        return this.preferenceService.getTokenDuration();
    }

    @Transactional
    public void deleteOldTokens() {
        String username = getPrincipal.getUsername();
        this.tokenService.deleteOldTokensByUser(username);
    }

    public boolean isAdmin() {
        return admin;
    }
}

gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/HomeBean.java
package net.ihe.gazelle.token.interlay.ihm;

import net.ihe.gazelle.token.interlay.annotation.LogAudited;
import net.ihe.gazelle.token.interlay.factory.TokenInfrastructureFactory;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

/**
 * @author Claude LUSSEAU
 * @company KEREVAL
 * @project gazelle-token
 * @date 11/07/2022
 */
@Named
@RequestScoped
@LogAudited
public class HomeBean {


    private final TokenInfrastructureFactory serviceFactory;

    @Inject
    public HomeBean(TokenInfrastructureFactory serviceFactory) {
        this.serviceFactory = serviceFactory;
    }


}

gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/MenuBean.java
package net.ihe.gazelle.token.interlay.ihm;

import net.ihe.gazelle.token.application.utils.DateFormatter;
import net.ihe.gazelle.token.interlay.annotation.LogAudited;
import net.ihe.gazelle.token.interlay.factory.TokenInfrastructureFactory;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * @author Claude LUSSEAU
 * @company KEREVAL
 * @project gazelle-token
 * @date 01/07/2022
 */
@Named
@LogAudited
@RequestScoped
public class MenuBean implements Serializable {

    private final TokenInfrastructureFactory serviceFactory;

    @Inject
    public MenuBean(TokenInfrastructureFactory serviceFactory) {
        this.serviceFactory = serviceFactory;
    }

    @Inject
    private DateFormatter formatter;

    private final LocalDateTime now = LocalDateTime.now();

    public String getNow() {
        return formatter.formatYearToString(now);
    }

    public String getVersion() {
        return this.serviceFactory.getServiceFactory().getPropertiesService().getVersion();
    }
}

gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/NavbarBean.java
package net.ihe.gazelle.token.interlay.ihm;

import javax.faces.annotation.ManagedProperty;
import javax.inject.Named;

/**
 * @author Claude LUSSEAU
 * @company KEREVAL
 * @project gazelle-token
 * @date 01/07/2022
 */
@Named
public class NavbarBean {

    @ManagedProperty(value="#{param.pageId}")
    private String pageId;

    private static final String LOGIN_LINK = "/gazelle-token-service/cas/login";

    public String loginLink() {
        return LOGIN_LINK;
    }

    public String getPageId() {
        return pageId;
    }

    public void setPageId(String pageId) {
        this.pageId = pageId;
    }

    public String displayPage() {
        if (pageId == null) {
            return "/gazelle-token-service/";
        }
        if (pageId.equals("Tokens")) {
            return "/gazelle-token-service/manager/";
        } else if (pageId.equals("Admin")) {
            return "/gazelle-token-service/manager/admin.xhtml";
        } else if (pageId.equals("Index")) {
            return "/gazelle-token-service/index.xhtml";
        } else {
            return "/gazelle-token-service/index.xhtml";
        }
    }
}

gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/PurgeBean.java
package net.ihe.gazelle.token.interlay.ihm;

import net.ihe.gazelle.token.interlay.annotation.LogAudited;
import net.ihe.gazelle.token.interlay.factory.TokenInfrastructureFactory;
import net.ihe.gazelle.token.interlay.ihm.model.GetPrincipal;

import javax.annotation.ManagedBean;
import javax.inject.Inject;
import javax.inject.Named;
import javax.transaction.Transactional;
import java.io.Serializable;

/**
 * @company KEREVAL
 * @author Claude LUSSEAU
 * @project gazelle-token
 * @date 16/07/2022
 */
@Named
@ManagedBean
@LogAudited
public class PurgeBean implements Serializable {

    private final TokenInfrastructureFactory serviceFactory;

    @Inject
    public PurgeBean(TokenInfrastructureFactory serviceFactory) {
        this.serviceFactory = serviceFactory;
    }

    @Inject
    private GetPrincipal principal;

    @Transactional
    public void deleteOldTokens() {
        this.serviceFactory.getServiceFactory().getTokenService().deleteOldTokensByUser(this.principal.getUsername());
    }
}

gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/TokenBean.java
package net.ihe.gazelle.token.interlay.ihm;

import net.ihe.gazelle.token.application.exception.UserNotFoundException;
import net.ihe.gazelle.token.domain.entity.Token;
import net.ihe.gazelle.token.interlay.annotation.LogAudited;
import net.ihe.gazelle.token.interlay.factory.TokenInfrastructureFactory;
import net.ihe.gazelle.token.interlay.ihm.model.GetPrincipal;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;
import javax.transaction.Transactional;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.Optional;

/**
 * @author Claude LUSSEAU
 * @company KEREVAL
 * @project gazelle-token
 * @date 04/07/2022
 */
@RequestScoped
@Named
@LogAudited
public class TokenBean implements Serializable {

    private static final long serialVersionUID = 1905122041950251207L;

    private final TokenInfrastructureFactory serviceFactory;

    @Inject
    private GetPrincipal principal;

    @Inject
    public TokenBean(TokenInfrastructureFactory serviceFactory) {
        this.serviceFactory = serviceFactory;
    }

    @PostConstruct
    public void init() {
        Optional<Token> activeToken;
        try {
            activeToken = getActiveToken();
        } catch (UserNotFoundException e) {
            activeToken = Optional.empty();
        }
    }

    public List<Token> getUserTokens() {
        String username = principal.getUsername();
        return serviceFactory.getServiceFactory().getTokenService().getAllTokenPerUser(username);
    }
    @Transactional
    public void createToken() throws UserNotFoundException {
        String username = principal.getUsername();
        String organization = principal.getOrganization();
        List<String> roles = principal.getRoles();
        serviceFactory.getServiceFactory().getTokenService().saveToken(username, organization, roles);
    }

    public Token getUniqueActiveToken() throws UserNotFoundException {
        return getActiveToken().get();
    }

    public boolean isActiveToken() throws UserNotFoundException {
        return getActiveToken().isPresent();
    }

    private Optional<Token> getActiveToken() throws UserNotFoundException {
        String username = principal.getUsername();
        return this.serviceFactory.getServiceFactory().getTokenService().getUniqueActiveToken(username);
    }

    @Transactional
    public void getDeactivateToken() throws UserNotFoundException {
        Token token = this.getUniqueActiveToken();
        this.serviceFactory.getServiceFactory().getTokenService().deactivateValidToken(token.getValue());
    }

    public boolean isExpired(String value) {
        Token token = this.serviceFactory.getServiceFactory().getTokenService().findByValue(value);
        return !token.getExpirationDate().isBefore(LocalDateTime.now());
    }
    @Transactional
    public void removeByUserExpiredTokens() {
        String username = principal.getUsername();
        this.serviceFactory.getServiceFactory().getTokenService().deleteOldTokensByUser(username);
    }

    public String getFormatDate(LocalDateTime dateTime) {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("dd/MM/yyyy HH:mm");
        return dateTime.format(formatter);
    }

}

gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/UserBean.java
package net.ihe.gazelle.token.interlay.ihm;

import net.ihe.gazelle.token.interlay.ihm.model.GetPrincipal;

import javax.annotation.PostConstruct;
import javax.enterprise.context.SessionScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.inject.Named;
import java.io.IOException;
import java.io.Serializable;

/**
 * @author Claude LUSSEAU
 * @company KEREVAL
 * @project gazelle-token
 * @date 27/06/2022
 */
@Named
@SessionScoped
public class UserBean implements Serializable {

    private GetPrincipal principal;

    private boolean logout = false;

    public boolean isLogout() {
        return logout;
    }

    private String username;
    private String organization;

    public String getUsername() {
        return username;
    }

    public String getOrganization() {
        return organization;
    }

    @PostConstruct
    public void init() {
        if (principal != null) {
            username = principal.getUsername();
            organization = principal.getOrganization();
        }
    }

    public void checkAlreadyLoggedIn() throws IOException {
        if (principal.isLoggedIn()) {
            ExternalContext ec = FacesContext.getCurrentInstance().getExternalContext();
            ec.redirect(ec.getRequestContextPath() + "/gazelle-token-service/");
        }
    }

}

gazelle-token-service-war/src/main/java/net/ihe/gazelle/token/interlay/ihm/util/GrowlBean.java
package net.ihe.gazelle.token.interlay.ihm.util;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Named;

/**
 * @company KEREVAL
 * @author Claude LUSSEAU
 * @project gazelle-token
 * @date 11/07/2022
 */
@Named
public class GrowlBean {

    public void resultCreateToken() {
        FacesContext context = FacesContext.getCurrentInstance();
        context.addMessage("growlForm:growl", new FacesMessage("",  "Le token à été correctement généré !") );
    }

    public void resultCopyToken() {
        FacesContext context = FacesContext.getCurrentInstance();
        context.addMessage("growlForm:copy", new FacesMessage("",  "Le token à été copié dans le presse-papier !") );
    }

    public void resultDeactivateToken() {
        FacesContext context = FacesContext.getCurrentInstance();
        context.addMessage("growlForm:deactivate", new FacesMessage("",  "Le token à été désactivé !") );
    }

    public void resultPurge() {
        FacesContext context = FacesContext.getCurrentInstance();
        context.addMessage("growlForm:purge", new FacesMessage("",  "Les tokens expirés ont été suprimés !") );
    }

    public void error() {
        FacesContext context = FacesContext.getCurrentInstance();
        context.addMessage("growlForm:error", new FacesMessage("",  "Une erreur c'est produite !") );
    }

}

gazelle-token-service-war/src/main/webapp/fragments/token/_actived_token_fragment.xhtml
<ui:fragment xmlns="http://www.w3.org/1999/xhtml"
             xmlns:h="http://java.sun.com/jsf/html"
             xmlns:ui="http://java.sun.com/jsf/facelets"
             xmlns:b="http://bootsfaces.net/ui"
             xmlns:f="http://xmlns.jcp.org/jsf/core"
             template="/layout/template.xhtml">

    <h:outputText class="text-secondary h4" value="Ce token est actuellement actif jusqu'au "/>
    <h:outputText class="text-secondary h4" value="#{tokenBean.uniqueActiveToken.expirationDate}">
        <f:convertDateTime type="localDateTime" pattern="dd/MM/yyyy 'à' HH:mm"/>
    </h:outputText>


    <b:form prependId="false" styleClass="gzl-mt-2rem">

        <b:inputText value="#{tokenBean.uniqueActiveToken.value}" id="copy-token" disabled="true">
            <f:facet name="append">
                <b:commandButton look="success" value="Copier la valeur  "
                                 iconAwesome="copy" show-summary="false"
                                 icon-align="right" onclick="copyTokenValue();"
                                 actionListener="#{growlBean.resultCopyToken()}" update="growl"/>
            </f:facet>
        </b:inputText>

    </b:form>

    <h:form class="gzl-mt-3rem">
        <h:outputText class="gzl-mr-2rem text-secondary h4 gzl-mb-2rem"
                      value="Si vous souhaitez générer un nouveau token, vous devez désactiver le token actif"/>
        <ui:include src="_deactivate-token_button_fragment.xhtml"/>
    </h:form>

</ui:fragment>

gazelle-token-service-war/src/main/webapp/fragments/token/_create_token_part_fragment.xhtml
<ui:fragment xmlns="http://www.w3.org/1999/xhtml"
             xmlns:h="http://java.sun.com/jsf/html"
             xmlns:ui="http://java.sun.com/jsf/facelets"
             xmlns:b="http://bootsfaces.net/ui"
             template="/layout/template.xhtml">

    <div>
        <h:panelGroup>
            <h:outputText class="alert-warning h3 gzl-ml-1rem gzl-mb-2rem" value="Pas de token actif"/>
        </h:panelGroup>
        <hr/>
    </div>
    <br/>
    <div>
        <h:panelGroup rendered="#{getPrincipal.loggedIn}">
            <b:column>
                <b:form>
                    <b:message for="activeToken" styleClass="errorBlock"/>
                    <h:outputText class="h4" value="Générer un nouveau token"/>
                    <br/>
                    <b:commandButton action="#{tokenBean.createToken()}" value="Créer un token"
                                     styleClass="btn btn-success btn-md gzl-mt-3rem gzl-mb-1rem" show-detail="true"
                                     show-summary="false"
                                     allowDismiss="true" oncomplete="function () { location.reload(); }"
                                     actionListener="#{growlBean.resultCreateToken()}" update="growl"/>
                </b:form>
            </b:column>
        </h:panelGroup>
    </div>
</ui:fragment>

gazelle-token-service-war/src/main/webapp/fragments/token/_deactivate-token_button_fragment.xhtml
<ui:fragment xmlns="http://www.w3.org/1999/xhtml"
             xmlns:ui="http://java.sun.com/jsf/facelets"
             xmlns:b="http://bootsfaces.net/ui"
             template="/layout/template.xhtml">
    <br/>
    <b:button look="danger" size="sg" class="gzl-mt-2rem gzl-mb-1rem gzl-ml-3rem gzl-align-center"
              onclick="$('.formValidationDeactivateToken').modal('show')"
              value="Désactiver le token"/>
    <b:modal title="Désactiver le token actif ?" styleClass="formValidationDeactivateToken"
             closable="false"
             closeOnEscape="true">

        <h4 class="font-italic gzl-mb-3rem red bold">Cette opération est irreversible !</h4>
        <h5 class="black">En désactivant ce token, vous ne pourrez plus être en mesure d'accéder au service Gazelle.</h5>
        <h5 class="black">Afin de pouvoir continuer à utiliser lesdits services, vous devrez créer un nouveau token.</h5>
        <b:row>
            <b:column>
                <b:form>
                    <b:button class="gzl-mt-2rem" largeScreen="half" value="Annuler"
                              dismiss="modal" onclick="return false;"/>
                    <b:commandButton class="gzl-mt-2rem" largeScreen="half" update="@form"
                                     dismiss="modal"
                                     value="Désactiver" look="danger"
                                     action="#{tokenBean.getDeactivateToken}"
                                     actionListener="#{growlBean.resultDeactivateToken()}"
                                     oncomplete="if(!validationFailed) { $('.formValidationDeactivateToken').modal('hide') }function () { location.reload(); }">
                    </b:commandButton>
                </b:form>
            </b:column>
        </b:row>
    </b:modal>
</ui:fragment>

gazelle-token-service-war/src/main/webapp/fragments/token/_delete_all_expired_user_tokens_fragment.xhtml
<ui:fragment xmlns="http://www.w3.org/1999/xhtml"
             xmlns:f="http://java.sun.com/jsf/core"
             xmlns:h="http://java.sun.com/jsf/html"
             xmlns:ui="http://java.sun.com/jsf/facelets"
             xmlns:b="http://bootsfaces.net/ui"
             template="/layout/template.xhtml">

    <f:facet name="heading">
        <b:icon value="fa-circle-info"/>
        <h:outputText value="Purger les tokens expirés" style="text-decoration: none"/>
    </f:facet>

    <h4>Important : </h4>
    <ul>
        <li>Pour supprimer l’historique de vos anciens tokens,</li>
        <li>Seuls les tokens expirés/désactivés seront supprimés.</li>
    </ul>

    <b:button look="danger" size="sg" class="gzl-mt-3rem gzl-mb-3rem gzl-ml-3rem gzl-align-center"
              onclick="$('.formValidationDeleteExpiredTokens').modal('show')"
              value="Supprimer les anciens tokens"/>

    <b:modal title="Purger les tokens ?" styleClass="formValidationDeleteExpiredTokens"
             closable="true" autoUpdate="false"
             closeOnEscape="true">

        <h4 class="font-italic gzl-mb-3rem red bold">Cette opération est irreversible !</h4>
        <h5 class="black">La suppression des tokens expirés / désactivés est définitive.</h5>
        <h5 class="black">Le token actif ne sera pas impacté par la suppression.</h5>
        <b:row>
            <b:column>
                <b:form>
                    <b:button class="gzl-mt-1rem" largeScreen="half" value="Annuler"
                              dismiss="modal" onclick="return false;"/>
                    <b:commandButton class="gzl-mt-1rem" largeScreen="half" update="@form"
                                     dismiss="modal" ajax="true"
                                     value="Supprimer" look="danger"
                                     action="#{tokenBean.removeByUserExpiredTokens()}"
                                     actionListener="#{growlBean.resultPurge()}"
                                     oncomplete="if(!validationFailed) { $('.formValidationDeleteExpiredTokens').modal('hide') }function () { location.reload(); }">
                    </b:commandButton>
                </b:form>
            </b:column>
        </b:row>
        <b:fetchBeanInfos/>
    </b:modal>
</ui:fragment>

gazelle-token-service-war/src/main/webapp/fragments/token/_list_user_tokens_fragment.xhtml
<ui:fragment xmlns="http://www.w3.org/1999/xhtml"
             xmlns:f="http://java.sun.com/jsf/core"
             xmlns:h="http://java.sun.com/jsf/html"
             xmlns:ui="http://java.sun.com/jsf/facelets"
             xmlns:b="http://bootsfaces.net/ui"
             template="/layout/template.xhtml">

    <h:form>
        <b:dataTable value="#{tokenBean.userTokens}"
                     var="token" responsive="true" scroll-size="400px" order="asc"
                     scroll-x="false" searching="false"
                     caption="Liste de tout les tokens générés">
            <b:dataTableColumn class="max-cell-size" value="#{token.value}" label="Valeur du token"/>
            <b:dataTableColumn class="col-hidden" value="#{tokenBean.getFormatDate(token.creationDate)}" label="Date de création"/>
            <b:dataTableColumn value="#{tokenBean.getFormatDate(token.expirationDate)}" label="Date de d'expiration"/>
            <b:dataTableColumn label="Etat du token">
                <b:label rendered="#{!tokenBean.isExpired(token.value)}" value="Expiré / Désactivé" severity="danger"/>
                <b:label rendered="#{tokenBean.isExpired(token.value)}" value="Valide" severity="success"/>
            </b:dataTableColumn>
        </b:dataTable>
    </h:form>
</ui:fragment>